sns_conta/WebUI/webUI.SICO/Models/EntityViewModel.cs
using businessLogic.Core;
using System.ComponentModel.DataAnnotations;

namespace webUI.SICO.Models
{
    public class EntityViewModel
    {
        [Display(Name = "Código Interno")]
        public int Id { get; set; }
        [Display(Name = "Nombre")]
        public string Name { get; set; }
        [Display(Name = "Número Identificación")]
        public string Document { get; set; }
        [Display(Name = "Tipo Entidad")]
        public EntityTypeEnum EntityType { get; set; }
        [Display(Name = "Tipo Identificación")]
        public string DocumentType { get; set; }
        [Display(Name = "Dirección")]
        public string Address { get; set; }
        [Display(Name = "Teléfono")]
        public string Telephone { get; set; }
        [Display(Name = "Activo")]
        public bool IsActive { get; set; }

        public EntityViewModel()
        {

        }

        public EntityViewModel(int id, string name, string document, string entityType, string documentType, string address, string telephone,bool isActive)
        {
            Id = id;
            Name = name;
            Document = document;
            EntityType = entityType== "JURIDICA"?EntityTypeEnum.JURIDICA:EntityTypeEnum.NATURAL;
            DocumentType = documentType;
            Address = address;
            Telephone = telephone;
            IsActive = isActive;
        }


    }
}

sns_conta/WebUI/webUI.SICO/Controllers/EntityController.cs
using businessLogic.Core;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using webUI.SICO.Models;

namespace webUI.SICO.Controllers
{
    public class EntityController : Controller
    {
        //TODO: Cambiar forma de edicion y mostrar detalles en EntityPerson
        // GET: EntityPerson
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult List()
        {
            var result = new List<EntityViewModel>();
            var companies = new businessLogic.Core.EntityPerson().GetAll("");
            foreach (var company in companies)
            {
                result.Add(new EntityViewModel(company.Id, company.Name,company.Document, company.EntityType, 
                    company.DocumentType.ToString(),company.Address, company.Telephone, company.IsActive));
            }
            return View(result);
        }

        public ActionResult Details(string Id)
        {
            var documentTypes = new DocumentType().GetAll(string.Empty);
            var company = new EntityPerson().GetOne(Id);
            string documentSelected = (from e in documentTypes where e.DocumentTypeId == company.DocumentType.ToString() select e.DocumentTypeName).FirstOrDefault();
            var result = new EntityViewModel(company.Id, company.Name, company.Document, company.EntityType,
                documentSelected, company.Address, company.Telephone, company.IsActive);
            return View(result);
        }

        public ActionResult AddNew()
        {
            ViewBag.DocumentTypes = new DocumentType().GetAll(string.Empty);
            return View(new EntityViewModel());
        }

        public ActionResult EditOne(string Id)
        {
            ViewBag.DocumentTypes = new DocumentType().GetAll(string.Empty);
            var company = new EntityPerson().GetOne(Id);
            var result = new EntityViewModel(company.Id, company.Name, company.Document, company.EntityType,
                company.DocumentType.ToString(), company.Address, company.Telephone, company.IsActive);
            return View(result);
        }


        [HttpPost]
        public JsonResult Save(EntityViewModel param)
        {

            ResponseModel result = new ResponseModel();
            try
            {
                var data = new businessLogic.Core.EntityPerson(param.Id,param.Name, param.Document, 
                    Enum.GetName(typeof(EntityTypeEnum),param.EntityType),param.DocumentType,param.Address,param.Telephone, true);
                var response = data.Add(data);
                result = new ResponseModel() { Id = "0", Message = string.Empty, Type = 'S' };                
            }
            catch (Exception ex)
            {
                result = new ResponseModel() { Id = "1", Message = ex.Message, Type = 'E' };
            }
            return Json(result, JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public JsonResult Delete(EntityViewModel param)
        {

            ResponseModel result = new ResponseModel();
            try
            {
                var data = new businessLogic.Core.EntityPerson(param.Id, "", "", "", "-1", "", "", true);
                var response = data.Remove(data);
                result = new ResponseModel() { Id = "0", Message = string.Empty, Type = 'S' };
            }
            catch (Exception ex)
            {
                result = new ResponseModel() { Id = "1", Message = ex.Message, Type = 'E' };
            }
            return Json(result, JsonRequestBehavior.AllowGet);
        }


        [HttpPost]
        public JsonResult Edit(EntityViewModel param)
        {
            ResponseModel result = new ResponseModel();
            try
            {
                var data = new businessLogic.Core.EntityPerson(param.Id, param.Name, param.Document, Enum.GetName(typeof(EntityTypeEnum), param.EntityType)
                    , param.DocumentType, param.Address, param.Telephone, true);
                var response = data.Update(data);
                result = new ResponseModel() { Id = "0", Message = string.Empty, Type = 'S' };
            }
            catch (Exception ex)
            {
                result = new ResponseModel() { Id = "1", Message = ex.Message, Type = 'E' };
            }
            return Json(result, JsonRequestBehavior.AllowGet);
        }


    }
}

sns_conta/WebUI/webUI.SICO/Views/Entity/AddNew.cshtml
@model webUI.SICO.Models.EntityViewModel

@{
    ViewBag.Title = "Agregar Nueva Entidad";
}

<div class="row">
    <div class="col-lg-12">
        <section class="card">
            <header class="card-header">
                <h4>
                    @ViewBag.Title
                    <span class="tools pull-right">
                        <a href="javascript:;" class="fa fa-chevron-down"></a>
                        <a href="javascript:;" class="fa fa-times"></a>
                    </span>
                </h4>
            </header>
            <div class="card-body">
                <button class="btn btn-default" type="button" onclick="location.href='../../Entity/List'">
                    <span class="fa fa-arrow-left"></span> Atras
                </button>
                <button id="btnSave" class="btn btn-success" type="button" onclick="fnSave()">
                    <span class="fa fa-save"></span> Guardar
                </button>

            </div>
        </section>
    </div>
</div>             

<div class="row">
    <div class="col-lg-12">
        <section class="card">
            <div class="card-body">
                <section id="flip-scroll">
                    @using (Html.BeginForm())
                    {
                        @Html.AntiForgeryToken()

                        <div class="form-horizontal">                            
                            @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                            <div class="form-group">
                                @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                                    @Html.ValidationMessageFor(model => model.Name, "Debe agregar un nombre", new { @class = "text-danger" })
                                </div>
                            </div>

                            <div class="form-group">
                                @Html.LabelFor(model => model.EntityType, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-lg-10">
                                    @Html.EnumDropDownListFor(model => model.EntityType, new { @class = "form-control" })
                                    @Html.ValidationMessageFor(model => model.EntityType, "Debe definir un tipo de entidad.", new { @class = "text-danger" })
                                </div>
                            </div>

                            <div class="form-group">
                                @Html.LabelFor(model => model.DocumentType, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    @Html.DropDownListFor(m => m.DocumentType, new SelectList(ViewBag.DocumentTypes, "DocumentTypeId", "DocumentTypeName",Model.DocumentType), new { @class = "form-control" })
                                    @Html.ValidationMessageFor(model => model.DocumentType, "Debe Definir un tipo de Documento", new { @class = "text-danger" })
                                </div>
                            </div>

                            <div class="form-group">
                                @Html.LabelFor(model => model.Document, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    @Html.EditorFor(model => model.Document, new { htmlAttributes = new { @class = "form-control" } })
                                    @Html.ValidationMessageFor(model => model.Document, "Debe agregar un documento de identidad", new { @class = "text-danger" })
                                </div>
                            </div>

                            <div class="form-group">
                                @Html.LabelFor(model => model.Address, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    @Html.EditorFor(model => model.Address, new { htmlAttributes = new { @class = "form-control" } })
                                    @Html.ValidationMessageFor(model => model.Address, "", new { @class = "text-danger" })
                                </div>
                            </div>

                            <div class="form-group">
                                @Html.LabelFor(model => model.Telephone, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    @Html.EditorFor(model => model.Telephone, new { htmlAttributes = new { @class = "form-control" } })
                                    @Html.ValidationMessageFor(model => model.Telephone, "", new { @class = "text-danger" })
                                </div>
                            </div>

                            <div class="form-group">
                                @Html.LabelFor(model => model.IsActive, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    <div class="checkbox">
                                        @Html.EditorFor(model => model.IsActive)
                                        @Html.ValidationMessageFor(model => model.IsActive, "", new { @class = "text-danger" })
                                    </div>
                                </div>
                            </div>
                        </div>
                    }
                </section>
            </div>
        </section>
    </div>
</div>

   

    @section Scripts {
        <script type="text/javascript">

        function fnSave()
        {

            var par = {};
            par.Id = 0;
            par.Name = $("#Name").val();
            par.Document = $("#Document").val();
            par.EntityType = $("#EntityType").val();
            par.DocumentType = $("#DocumentType").val();
            par.Address = $("#Address").val();
            par.Telephone = $("#Telephone").val();


            $.ajax({
              url: ('@Url.Action("Save", "Entity")'),
              type: "POST",
              async:false,
              data: '{param:' + JSON.stringify(par) + '}',
              dataType: "json",
              contentType: "application/json; charset=utf-8",
              success: function (result) {
                  if (result.Type == "E") {
                      toastr.error(result.Message);
                  }
                  else {
                      toastr.success('Se guardo correctamente.');
                      location.href = '/Entity/List';
                  }


              },
              error: function (result) {
                  toastr.error('Se produjo un error inesperado', 'Error');
              }
            });
        }




        </script>

        @Scripts.Render("~/bundles/jqueryval")
    }

sns_conta/WebUI/webUI.SICO/Views/Entity/EditOne.cshtml
@model webUI.SICO.Models.EntityViewModel

@{
    ViewBag.Title = "Editar";
}

<div class="row">
    <div class="col-lg-12">
        <section class="card">
            <header class="card-header">
                <h4>
                    @ViewBag.Title
                    <span class="tools pull-right">
                        <a href="javascript:;" class="fa fa-chevron-down"></a>
                        <a href="javascript:;" class="fa fa-times"></a>
                    </span>
                </h4>
            </header>
            <div class="card-body">
                <button class="btn btn-default" type="button" onclick="location.href='/Entity/List'">
                    <span class="fa fa-arrow-left"></span> Atr&aacute;s...
                </button>
                <button id="btnSave" class="btn btn-success" type="button" onclick="fnEdit()">
                    <span class="fa fa-save"></span> Guardar
                </button>
            </div>

        </section>
    </div>
</div>


<div class="row">
    <div class="col-lg-12">
        <section class="card">
            <div class="card-body">
                <section id="flip-scroll">
                    @using (Html.BeginForm())
                    {
                        @Html.AntiForgeryToken()

                        <div class="form-horizontal">
                            <h4>Entidad</h4>
                            <hr />
                            @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                            @Html.HiddenFor(model => model.Id)

                            <div class="form-group">
                                @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                                    @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
                                </div>
                            </div>

                            <div class="form-group">
                                @Html.LabelFor(model => model.EntityType, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    @Html.EnumDropDownListFor(model => model.EntityType, new { @class = "form-control" })
                                    @Html.ValidationMessageFor(model => model.EntityType, "", new { @class = "text-danger" })
                                </div>
                            </div>
                            
                            <div class="form-group">
                                @Html.LabelFor(model => model.DocumentType, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    @Html.DropDownListFor(m => m.DocumentType, new SelectList(ViewBag.DocumentTypes, "DocumentTypeId", "DocumentTypeName", Model.DocumentType), new { @class = "form-control" })
                                    @Html.ValidationMessageFor(model => model.DocumentType, "", new { @class = "text-danger" })
                                </div>
                            </div>

                            <div class="form-group">
                                @Html.LabelFor(model => model.Document, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    @Html.EditorFor(model => model.Document, new { htmlAttributes = new { @class = "form-control" } })
                                    @Html.ValidationMessageFor(model => model.Document, "", new { @class = "text-danger" })
                                </div>
                            </div>


                            <div class="form-group">
                                @Html.LabelFor(model => model.Address, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    @Html.TextAreaFor(model => model.Address, new { @class = "form-control" })
                                    @Html.ValidationMessageFor(model => model.Address, "", new { @class = "text-danger" })
                                </div>
                            </div>

                            <div class="form-group">
                                @Html.LabelFor(model => model.Telephone, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    @Html.EditorFor(model => model.Telephone, new { htmlAttributes = new { @class = "form-control" } })
                                    @Html.ValidationMessageFor(model => model.Telephone, "", new { @class = "text-danger" })
                                </div>
                            </div>

                            <div class="form-group">
                                @Html.LabelFor(model => model.IsActive, htmlAttributes: new { @class = "control-label col-md-2" })
                                <div class="col-md-10">
                                    <div class="form-check">
                                        @Html.EditorFor(model => model.IsActive, new { htmlAttributes = new { @class = "form-check-input" } })
                                        @Html.ValidationMessageFor(model => model.IsActive, "", new { @class = "text-danger" })
                                    </div>
                                </div>
                            </div>


                        </div>
                    }
                </section>
            </div>
        </section>
    </div>
</div>


                    

                    @section Scripts {

                        <script type="text/javascript">

        function fnEdit()
        {

            var par = {};
            par.Id = $("#Id").val();;
            par.Name = $("#Name").val();
            par.Document = $("#Document").val();
            par.EntityType = $("#EntityType").val();
            par.DocumentType = $("#DocumentType").val();
            par.Address = $("#Address").val();
            par.Telephone = $("#Telephone").val();

            $.ajax({
              url: ('@Url.Action("Edit", "Entity")'),
              type: "POST",
              async:false,
              data: '{param:' + JSON.stringify(par) + '}',
              dataType: "json",
              contentType: "application/json; charset=utf-8",
              success: function (result) {
                  if (result.Type == "E") {
                      toastr.error(result.Message);
                  }
                  else {
                      toastr.success('Se guardo correctamente.');
                      location.href = '/Entity/List';
                  }


              },
              error: function (result) {
                  toastr.error('Se produjo un error inesperado', 'Error');
              }
            });
        }



         function fnRecargar()
         {
             location.reload(true);
         }


                        </script>

                        @Scripts.Render("~/bundles/jqueryval")
                    }

sns_conta/WebUI/webUI.SICO/Views/Entity/List.cshtml
@model IEnumerable<webUI.SICO.Models.EntityViewModel>

@{
    ViewBag.Title = "Entidades";
}

<div class="row">
    <div class="col-lg-12">
        <section class="card">
            <header class="card-header">
                <h4>
                    @ViewBag.Title
                    <span class="tools pull-right">
                        <a href="javascript:;" class="fa fa-chevron-down"></a>
                        <a href="javascript:;" class="fa fa-times"></a>
                    </span>
                </h4>
            </header>
            <div class="card-body">
                <a href="../Home/Index/" class="btn btn-shadow btn-default">
                    <span class="fa fa-arrow-left"></span> Atr&aacute;s...
                </a>
                <button class="btn btn-shadow btn-success" type="button" onclick="location.href='../Entity/AddNew/'">
                    <span class="fa fa-plus"></span> Nuevo
                </button>                
            </div>

        </section>
    </div>
</div>

<div class="row">
    <div class="col-lg-12">
        <section class="card">
            <div class="card-body">
                <section id="flip-scroll">
                    <table class="table table-bordered table-striped table-condensed cf">
                        <thead class="cf">
                            <tr>
                                <th width="55%">
                                    Nombre
                                </th>
                                <th width="25%">
                                    Tipo
                                </th>
                                <th width="20%"> Opciones</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach (var item in Model)
                            {
                                <tr>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.Name)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.EntityType)
                                    </td>
                                    <td>

                                        <span class="input-group-btn">
                                            <button class="btn btn-sm btn-default" type="button" onclick="location.href='../Entity/Details/@item.Id'">
                                                <span class="fa fa-eye"></span>
                                            </button>
                                            <button class="btn btn-sm btn-default" type="button" onclick="location.href='../Entity/EditOne/@item.Id'">
                                                <span class="fa fa-pencil"></span>
                                            </button>
                                            <button class="btn btn-sm btn-danger" type="button" onclick="fnDelete(@item.Id)">
                                                <span class="fa fa-trash-o"></span>
                                            </button>
                                        </span>
                                    </td>
                                </tr>
                            }
                        </tbody>
                    </table>
                </section>
            </div>
        </section>
    </div>
</div>
    
        

      

    <!--==========================================================CREAR=============================================================-->
    <div class="modal inmodal" id="CreateModal" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content animated bounceInRight">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Salir</span></button>
                    <i class="fa fa-laptop modal-icon"></i>
                    <h4 class="modal-title">Crear Empresa</h4>
                    <!--<small class="font-bold">Seleccione uno de los proveedores del resultado.</small>-->
                </div>
                <div class="modal-body">
                    <div class="form-group">

                        <label class="control-label">Nombre:</label>
                        <div class="input-group">
                            <input type="text" id="txtName" name="txtName" value="" class="col-sm-1 form-control">
                        </div>
                        <hr />
                        <div class="input-group">
                            <span class="input-group-btn">
                                <button id="btnSave" class="btn btn-success" type="button" onclick="fnSave()">
                                    <span class="glyphicon glyphicon-save"></span>
                                    Guardar
                                </button>
                            </span>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>



    <!--==========================================================MODIFICAR=============================================================-->
    <div class="modal inmodal" id="EditModal" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content animated bounceInRight">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Salir</span></button>
                    <i class="fa fa-laptop modal-icon"></i>
                    <h4 class="modal-title">Editar @ViewBag.Title</h4>
                    <!--<small class="font-bold">Seleccione uno de los proveedores del resultado.</small>-->
                </div>
                <div class="modal-body">
                    <div class="form-group">

                        <label class="control-label">Id:</label>
                        <div class="input-group">
                            <input type="text" id="txtEditId" name="txtEditId" value="" class="col-sm-1 form-control" disabled>
                        </div>
                        <label class="control-label">Nombre:</label>
                        <div class="input-group">
                            <input type="text" id="txtEditName" name="txtEditName" value="" class="col-sm-1 form-control">
                        </div>
                        <hr />
                        <div class="input-group">
                            <span class="input-group-btn">
                                <button id="btnEditSave" class="btn btn-success" type="button" onclick="fnEdit()">
                                    <span class="glyphicon glyphicon-save"></span>
                                    Guardar
                                </button>
                            </span>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>



    @section Scripts {
        <script type="text/javascript">

        function fnLoadEdit(id, name)
        {
            $("#txtEditId").val(id);
            $("#txtEditName").val(name);

        }

        function fnSave()
        {

            var par = {};
            par.Id = 0;
            par.Name = $("#txtName").val();

            $.ajax({
              url: ('@Url.Action("Save", "Entity")'),
              type: "POST",
              async:false,
              data: '{param:' + JSON.stringify(par) + '}',
              dataType: "json",
              contentType: "application/json; charset=utf-8",
              success: function (result) {
                  if (result.Type == "E") {
                      toastr.error(result.Message);
                      $("#CreateModal").modal('hide');
                  }
                  else {
                      toastr.success('Se guardo correctamente.');
                      $("#txtName").prop('disabled', true);
                      $("#btnSave").prop('disabled', true);

                      fnRecargar();
                  }


              },
              error: function (result) {
                  toastr.error('Se produjo un error inesperado', 'Error');
              }
            });
        }

        function fnDelete(id)
        {

            var par = {};
            par.Id = id;


            $.ajax({
              url: ('@Url.Action("Delete", "Entity")'),
              type: "POST",
              async:false,
              data: '{param:' + JSON.stringify(par) + '}',
              dataType: "json",
              contentType: "application/json; charset=utf-8",
              success: function (result) {
                  if (result.Type == "E") {
                      toastr.error(result.Message);
                      fnRecargar();
                  }
                  else {
                      toastr.success('Se elimino correctamente.');
                      fnRecargar();
                  }
              },
              error: function (result) {
                  toastr.error('Se produjo un error inesperado', 'Error');
              }
            });
        }

        function fnEdit()
        {

            var par = {};
            par.Id = $("#txtEditId").val();;
            par.Name = $("#txtEditName").val();

            $.ajax({
              url: ('@Url.Action("Edit", "Entity")'),
              type: "POST",
              async:false,
              data: '{param:' + JSON.stringify(par) + '}',
              dataType: "json",
              contentType: "application/json; charset=utf-8",
              success: function (result) {
                  if (result.Type == "E") {
                      toastr.error(result.Message);
                      $("#EditModal").modal('hide');
                  }
                  else {
                      toastr.success('Se guardo correctamente.');
                      $("#txtEditName").prop('disabled', true);
                      $("#btnEditSave").prop('disabled', true);

                      fnRecargar();
                  }


              },
              error: function (result) {
                  toastr.error('Se produjo un error inesperado', 'Error');
              }
            });
        }



         function fnRecargar()
         {
             location.reload(true);
         }


        </script>

        @Scripts.Render("~/bundles/jqueryval")
    }